package {

import flash.display.Sprite;
//import flash.display.Shape;
import flash.events.MouseEvent;
import flash.events.TimerEvent;
import flash.utils.Timer;
import flash.text.TextFormat;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.text.TextFormatAlign;
import flash.text.Font;
import flash.net.SharedObject;

import Track;
import Log;

// Main game class for Hurdles.
public class Hurdles extends Sprite {

  static private var TICK_FREQUENCY:Number = 60;
  static private var RESTART_DELAY:Number = 30;

  static private var SCORE_DISPLAY_FONT_SIZE:Number = 50;
  static private var SCORE_DISPLAY_X:Number = 50;
  static private var SCORE_DISPLAY_Y:Number = 180;

  static private var TITLE_DISPLAY_FONT_SIZE:Number = 150;
  static private var TITLE_DISPLAY_Y:Number = 50;

  static private var PROMPT_DISPLAY_FONT_SIZE:Number = 50;
  static private var PROMPT_DISPLAY_Y:Number = 450;

  static private var HIGH_SCORE_DISPLAY_FONT_SIZE:Number = 30;
  static private var HIGH_SCORE_DISPLAY_Y:Number = 550;

  static private var INSTRUCTION_DISPLAY_FONT_SIZE:Number = 24;

  private var tickTimer:Timer;
  //  private var hurdleLine:Shape;
  private var tracks:Vector.<Track>;
  private var numTracksSquareRoot:Number;
  private var numColumns:Number;
  private var numRows:Number;
  private var scaleFactorX:Number;
  private var scaleFactorY:Number;
  private var trackWidth:Number;
  private var trackHeight:Number;
  private var totalScore:Number;
  private var firstTime:Boolean;
  private var reactionDelay:Number;
  //  private var highScore:Number;
  private var title:TextField;
  private var scoreDisplay:TextField;
  private var tapPrompt:TextField;
  private var highScoreDisplay:TextField;

  private var instructions1:TextField;
  private var instructions2:TextField;
  private var instructions3:TextField;
  private var instructions4:TextField;
  private var instructions5:TextField;

  private var saveFile:SharedObject;

[Embed(source="../rsc/Arcade.ttf", fontName="HurdlesFont", mimeType="application/x-font", embedAsCFF="false")]
  private var HurdlesFont:Class;

  // Application entry point.
  public function Hurdles() {
    //    Font.registerFont(HurdlesFont);

    //    hurdleLine = new Shape();
    //    hurdleLine.graphics.lineStyle(1, 0x000000);
    //    hurdleLine.graphics.moveTo(0, 0);
    //    hurdleLine.graphics.lineTo(800, 0);
    //    hurdleLine.y = 300;
    totalScore = 0;
    firstTime = true;
    reactionDelay = 0;
    //    highScore = 0;

    saveFile = SharedObject.getLocal("saveData");

    if(saveFile.data.highScore == null) {
      saveFile.data.highScore = 0;
    }

    tracks = new Vector.<Track>;
    //    addNewTrack();

    var format:TextFormat = new TextFormat();
    format.font = "HurdlesFont";
    format.size = SCORE_DISPLAY_FONT_SIZE;
    format.bold = true;
    format.align = TextFormatAlign.CENTER;

    scoreDisplay = new TextField();
    scoreDisplay.width = 800;
    scoreDisplay.defaultTextFormat = format;
    scoreDisplay.selectable = false;
    scoreDisplay.embedFonts = true;
    scoreDisplay.x = 0;
    scoreDisplay.y = SCORE_DISPLAY_Y;
    scoreDisplay.textColor = 0xffff00;
    scoreDisplay.visible = true;
    scoreDisplay.text = "Instructions:";
    addChild(scoreDisplay);

    var titleFormat:TextFormat = new TextFormat();
    titleFormat.font = "HurdlesFont";
    titleFormat.size = TITLE_DISPLAY_FONT_SIZE;
    titleFormat.bold = true;
    titleFormat.align = TextFormatAlign.CENTER;

    title = new TextField();
    title.width = 800;
    title.defaultTextFormat = titleFormat;
    title.selectable = false;
    title.embedFonts = true;
    title.x = 0;
    title.y = TITLE_DISPLAY_Y;
    title.textColor = 0xffff00;
    title.visible = true;
    title.text = "Hurdles";
    addChild(title);

    var promptFormat:TextFormat = new TextFormat();
    promptFormat.font = "HurdlesFont";
    promptFormat.size = PROMPT_DISPLAY_FONT_SIZE;
    promptFormat.bold = true;
    promptFormat.align = TextFormatAlign.CENTER;

    tapPrompt = new TextField();
    tapPrompt.width = 800;
    tapPrompt.defaultTextFormat = promptFormat;
    tapPrompt.selectable = false;
    tapPrompt.embedFonts = true;
    tapPrompt.x = 0;
    tapPrompt.y = PROMPT_DISPLAY_Y;
    tapPrompt.textColor = 0xffff00;
    tapPrompt.visible = true;
    tapPrompt.text = "Click To Begin";
    addChild(tapPrompt);

    var highFormat:TextFormat = new TextFormat();
    highFormat.font = "HurdlesFont";
    highFormat.size = HIGH_SCORE_DISPLAY_FONT_SIZE;
    highFormat.bold = true;
    highFormat.align = TextFormatAlign.RIGHT;

    highScoreDisplay = new TextField();
    highScoreDisplay.width = 750;
    highScoreDisplay.defaultTextFormat = highFormat;
    highScoreDisplay.selectable = false;
    highScoreDisplay.embedFonts = true;
    highScoreDisplay.x = 0;
    highScoreDisplay.y = HIGH_SCORE_DISPLAY_Y;
    highScoreDisplay.textColor = 0xffff00;
    highScoreDisplay.visible = true;
    highScoreDisplay.text = "High Score: " + String(saveFile.data.highScore);
    addChild(highScoreDisplay);



    var instructionFormat:TextFormat = new TextFormat();
    instructionFormat.font = "HurdlesFont";
    instructionFormat.size = INSTRUCTION_DISPLAY_FONT_SIZE;
    instructionFormat.bold = true;
    instructionFormat.align = TextFormatAlign.CENTER;

    instructions1 = new TextField();
    instructions1.width = 800;
    instructions1.defaultTextFormat = instructionFormat;
    instructions1.selectable = false;
    instructions1.embedFonts = true;
    instructions1.x = 0;
    instructions1.y = SCORE_DISPLAY_Y + 55;
    instructions1.textColor = 0xffff00;
    instructions1.visible = true;
    instructions1.text = "Clear hurdles to earn points. Blue: +1pt  Green: +4pt  Red: +9pt";
    addChild(instructions1);

    instructions2 = new TextField();
    instructions2.width = 800;
    instructions2.defaultTextFormat = instructionFormat;
    instructions2.selectable = false;
    instructions2.embedFonts = true;
    instructions2.x = 0;
    instructions2.y = SCORE_DISPLAY_Y + 95;
    instructions2.textColor = 0xffff00;
    instructions2.visible = true;
    instructions2.text = "Runners try to jump automatically and improve with each hurdle cleared";
    addChild(instructions2);

    instructions3 = new TextField();
    instructions3.width = 800;
    instructions3.defaultTextFormat = instructionFormat;
    instructions3.selectable = false;
    instructions3.embedFonts = true;
    instructions3.x = 0;
    instructions3.y = SCORE_DISPLAY_Y + 135;
    instructions3.textColor = 0xffff00;
    instructions3.visible = true;
    instructions3.text = "Color of runner matches tallest hurdle size they can currently jump";
    addChild(instructions3);

    instructions4 = new TextField();
    instructions4.width = 800;
    instructions4.defaultTextFormat = instructionFormat;
    instructions4.selectable = false;
    instructions4.embedFonts = true;    instructions4.x = 0;
    instructions4.y = SCORE_DISPLAY_Y + 175;
    instructions4.textColor = 0xffff00;
    instructions4.visible = true;
    instructions4.text = "Click a box to lower next hurdle. Each click creates a new box!";
    addChild(instructions4);

    instructions5 = new TextField();
    instructions5.width = 800;
    instructions5.defaultTextFormat = instructionFormat;
    instructions5.selectable = false;
    instructions5.embedFonts = true;
    instructions5.x = 0;
    instructions5.y = SCORE_DISPLAY_Y + 215;
    instructions5.textColor = 0xffff00;
    instructions5.visible = true;
    instructions5.text = "Runners die when touching left box edge: -1pt";
    addChild(instructions5);




    //    graphics.moveTo(1, 1);
    //    graphics.lineTo(799, 1);
    //    graphics.lineTo(799, 599);
    //    graphics.lineTo(1, 599);
    //    graphics.lineTo(1, 1);


    graphics.clear();
    graphics.lineStyle(2, 0x000000);
    graphics.beginFill(0x111111, 1);
    //    graphics.beginFill(0x333333, 1);
    graphics.drawRect(0, 0, 800, 600);
    graphics.endFill();

    //    addChild(gameTitle);

    stage.addEventListener(MouseEvent.CLICK, clickListener);

    tickTimer = new Timer(TICK_FREQUENCY, 0);
    tickTimer.addEventListener(TimerEvent.TIMER, update);
    tickTimer.start();
  }

  private function clickListener(e:MouseEvent):void {
    if(firstTime) {
      scoreDisplay.visible = false;
      title.visible = false;
      tapPrompt.visible = false;
      highScoreDisplay.visible = false;
      instructions1.visible = false;
      instructions2.visible = false;
      instructions3.visible = false;
      instructions4.visible = false;
      instructions5.visible = false;
      addNewTrack();
      firstTime = false;
    }
    else if(tracks.length == 0) {
      if(reactionDelay > RESTART_DELAY) {
	reactionDelay = 0;
	scoreDisplay.visible = false;
	title.visible = false;
	tapPrompt.visible = false;
	highScoreDisplay.visible = false;
	totalScore = 0;
	addNewTrack();
      }
    }
    else {

      var mouseClickColumn:Number = Math.floor(e.stageX / trackWidth);
      var mouseClickRow:Number = Math.floor(e.stageY / trackHeight);
      var trackIndex:Number = (mouseClickRow * numColumns) + mouseClickColumn;

      if(trackIndex < tracks.length && !tracks[trackIndex].isFinished()) {
	tracks[trackIndex].handleClick();
	addNewTrack();
      }
    }
  }

  private function addNewTrack():void {
    var createNewTrack:Boolean = true;

    for(var k:int = 0; k < tracks.length; ++k) {
      if(tracks[k].isFinished()) {
	tracks[k].reset();
	createNewTrack = false;
	break;
      }
    }

    if(createNewTrack) {
      var trackToAdd:Track = new Track();
      tracks.push(trackToAdd);
      //      stage.addChild(trackToAdd);
      addChild(trackToAdd);
      updateTrackPositioning();
    }

    //    for(var k:int = 0; k < tracks.length; ++k) {
    //      tracks[k].update();
    //    }

  }

  private function updateTrackPositioning():void {

    numTracksSquareRoot = Math.sqrt(tracks.length);
    numColumns = Math.ceil(numTracksSquareRoot);
    //    var numRows:Number = Math.floor(numTracksSquareRoot);
    numRows = Math.ceil(numTracksSquareRoot);
    //    var halfLineThickness:Number = Track.LINE_THICKNESS / 2;

    scaleFactorX = 1.0 / numColumns;
    scaleFactorY = 1.0 / numRows;
    trackWidth = Track.WINDOW_WIDTH * scaleFactorX;
    trackHeight = Track.WINDOW_HEIGHT * scaleFactorY;

    for(var i:int = 0; i < tracks.length; ++i) {
      tracks[i].scaleX = scaleFactorX;
      tracks[i].scaleY = scaleFactorY;
      //      tracks[i].x = halfLineThickness + ((i % numTracksPerRow) * tracks[i].scaleX);
      //      tracks[i].y = halfLineThickness + (Math.floor(i / numTracksPerRow) * ((Track.WINDOW_HEIGHT - halfLineThickness) * tracks[i].scaleY));

      tracks[i].x = (i % numColumns) * trackWidth;
      tracks[i].y = Math.floor(i / numColumns) * trackHeight;
    }

    ///////////////////////////////////////
    //    var halfLineThickness:Number = Track.LINE_THICKNESS / 2;

    //    for(var i:int = 0; i < tracks.length; ++i) {
    //      tracks[i].scaleY = (1.0 / tracks.length);
    //      tracks[i].y = halfLineThickness + (i * ((Track.WINDOW_HEIGHT - halfLineThickness) * tracks[i].scaleY));
    //    }
    ///////////////////////////////////////
  }

  private function update(e:TimerEvent):void {
    //    Log.print("Game loop entered!");
    var wasTrackFinished:Boolean = true;
    var allTracksFinished:Boolean = true;

    for(var j:int = 0; j < tracks.length; ++j) {
      //      if(!tracks[j].isFinished()) {
      wasTrackFinished = tracks[j].isFinished();
      tracks[j].update();

      if(!tracks[j].isFinished()) {
	allTracksFinished = false;
      }
      else if(!wasTrackFinished) {
	totalScore += tracks[j].getScore();
	totalScore = Math.max(totalScore - Track.LOST_POINTS_ON_FINISH, 0);
      }
	//      }

      //      if(tracks[j].isFinished()) {
	//	stage.removeChild(tracks[j]);
	//	tracks.splice(j, 1);
      //      }
      //      else {
      //	++j;
      //      }
    }

    if(tracks.length > 0 && allTracksFinished) {
      scoreDisplay.text = "Final Score: " + String(totalScore);
      scoreDisplay.visible = true;
      title.text = "New Record";
      //      title.visible = true;
      tapPrompt.text = "Click To Try Again";
      //      tapPrompt.visible = true;
      highScoreDisplay.text = "High Score: " + String(saveFile.data.highScore);
      highScoreDisplay.visible = true;

      for(var p:int = 0; p < tracks.length; ++p) {
	removeChild(tracks[p]);
      }

      tracks.length = 0;
    }

    if(!firstTime && tracks.length == 0) {
      ++reactionDelay;

      if(reactionDelay == RESTART_DELAY) {
	tapPrompt.visible = true;

	if(totalScore > saveFile.data.highScore) {
	  saveFile.data.highScore = totalScore;
	  highScoreDisplay.text = "High Score: " + String(saveFile.data.highScore);
	  title.visible = true;
	}
      }
    }

    updateTrackPositioning();

    e.updateAfterEvent();
  }

}

}