package {

import Log;

// Class for an individual hurdle obstacle.
public class Obstacle {

  static public var OBSTACLE_HEIGHT_UNIT:Number = 50;
  static public var OBSTACLE_WIDTH:Number = 50;

  static public var HEIGHT_SMALL:Number = 1;
  static public var HEIGHT_MEDIUM:Number = 2;
  static public var HEIGHT_LARGE:Number = 3;
  //  static public var HEIGHT_RANDOM:Number = 4;

  static public var OBSTACLE_COLOR_SMALL:Number = 0x0000ff;
  static public var OBSTACLE_COLOR_MEDIUM:Number = 0x00ff00;
  static public var OBSTACLE_COLOR_LARGE:Number = 0xff0000;

  private var linePosition:Number;
  private var height:Number;

  // Application entry point.
  public function Obstacle(position:Number, obstacleHeight:Number = 4) {
    linePosition = position;

    if(obstacleHeight < HEIGHT_SMALL || obstacleHeight > HEIGHT_LARGE) {
      height = HEIGHT_SMALL + Math.floor(Math.random() * HEIGHT_LARGE);//2.99999999);
    }
    else {
      height = obstacleHeight;
    }
  }

  public function getLinePosition():Number {
    return linePosition;
  }

  public function getUnitHeight():Number {
    return height;
  }

  public function getHeight():Number {
    return height * OBSTACLE_HEIGHT_UNIT;
  }

  public function handleClick():void {
    height = Math.max(height - 1, 0);
  }

}

}